// D import file generated from 'sqlite/database.d'
module sqlite.database;
private import std.string;

private import etc.c.sqlite3;

public import std.variant;

private import std.conv;

private import core.exception : RangeError;

public import sqlite.table;

public import sqlite.statement;

public import sqlite.exception;

debug (1)
{
    private import std.stdio;

}
Database executeScript(string databasePath, string[] lines...);
class Database
{
    private 
{
    string _databasePath;
    sqlite3* _connection;
    Table[string] _tables;
    Statement _statement;
    public 
{
    this(string databasePath, bool inMemory = false);
    ~this()
{
sqlite3_exec(_connection,"END",null,null,null);
sqlite3_close(_connection);
}
    void createTable(string tableName, string[] columns...);
    void createTable(string query);
    void dropTable(string tableName)
{
string query = "DROP TABLE " ~ tableName;
command(query);
if (tableName in _tables)
_tables.remove(tableName);
}
    @property sqlite3* connection()
{
return _connection;
}

    @property Row[] tables()
{
return command("SELECT name FROM sqlite_master WHERE type='table'");
}

    @property void updateTablesList();

    Row[] table_info(string tableName)
{
return _statement.prepare("PRAGMA table_info( " ~ tableName ~ " )");
}
    Row[] command(string query)
{
return _statement.prepare(query);
}
    void command(string[] querys)
{
_statement.prepare(querys);
}
    Row[] command(string query, Variant[] values...)
{
return _statement.prepare(query,values);
}
    void command(string[] querys, Variant[][] values...)
{
_statement.prepare(querys,values);
}
    int opApply(int delegate(ref Table) dg);
    Table opIndex(string name);
}
}
}
