// D import file generated from 'sqlite/statement.d'
module sqlite.statement;
private import std.variant;

private import std.ascii : newline;

private import std.conv;

private import std.string;

private import etc.c.sqlite3;

private import sqlite.exception;

private import sqlite.database;

debug (1)
{
    private import std.stdio;

}
struct Statement
{
    private 
{
    sqlite3_stmt* _statement;
    char* _lineError;
    bool _isPrepared;
    int _columnCount;
    Database _database;
    size_t _columnType(int column);
    void _bind(Variant[] values...);
    public 
{
    bool autoExecute;
    this(Database db)
{
_database = db;
autoExecute = true;
}
    ~this()
{
finalyze;
}
    Row[] prepare(string query);
    void prepare(string[] querys);
    Row[] prepare(string query, Variant[] values...);
    void prepare(string[] querys, Variant[][] values...);
    @property Row[] execute();

    @property size_t length()
{
return _columnCount;
}

    @property void finalyze()
{
sqlite3_finalize(_statement);
}

    string databaseName(int column);
    string tableName(int column);
    string originName(int column);
    string columnName(int column);
    Variant columnValue(int column);
    int opApply(int delegate(ref int) dg);
}
}
}
struct Row
{
    private 
{
    Column[] _columns;
    public 
{
    this(Column[] columns)
{
_columns = columns.dup;
}
    int opApply(int delegate(ref Column) dg);
    int opApply(int delegate(ref size_t index, ref Column) dg);
    string toString();
    Column opIndex(size_t index)
{
return _columns[index];
}
    Column opIndex(string name);
}
}
}
struct Column
{
    private 
{
    Variant _value;
    string _name;
    public 
{
    this(string name)
{
_name = name;
}
    this(Variant value, string name)
{
_value = value;
_name = name;
}
    @property string name()
{
return _name;
}

    @property template value(T)
{
void value(T item)
{
_value = item;
}
}

    @property Variant getValue()
{
return _value;
}

    Variant opCall()
{
return _value;
}
    string toString()
{
return "%s: %s".format(name,_value);
}
}
}
}
@property string header(Row[] rows);

