// D import file generated from 'sqlite/table.d'
module sqlite.table;
private import std.string;

private import std.array;

private import std.variant;

private import sqlite.statement;

private import sqlite.database;

debug (1)
{
    private import std.stdio;

}
final class Table
{
    private 
{
    Database _database;
    string _name;
    string _bindValues(ref Variant[] values)
{
string bindValues = "?, ".replicate(values.length);
return bindValues[0..$ - 2];
}
    public 
{
    this(ref Database database, string name)
{
_database = database;
_name = name.idup;
}
    template insert(T)
{
void insert(T[] values, string[] columns = null)
{
string query = "";
string bindValues = _bindValues(values);
if (columns is null)
query = "INSERT INTO `%s` VALUES ( %s )".format(_name,bindValues);
else
query = "INSERT INTO `%s` ( %s ) VALUES ( %s )".format(_name,columns.join(", "),bindValues);
_database.command(query,values);
}
}
    template insert(T)
{
void insert(T[][] values, string[] columns = null)
{
foreach (value; values)
{
insert(value,columns);
}
}
}
    template insert(T)
{
void insert(T[][] values, string[][] columns = null)
{
if (values.length != columns.length)
throw new TableException(" Array values and array columns need to be same length: %s != %s".format(values.length,columns.length),"sqlite/table.d",61);
foreach (index; 0 .. values.length)
{
insert(values[index],columns[index]);
}
}
}
    template replace(T)
{
void replace(T[] values, string[] columns = null)
{
string query = "";
string bindValues = _bindValues(values);
if (columns is null)
query = "REPLACE INTO `%s` VALUES ( %s )".format(_name,bindValues);
else
query = "REPLACE INTO `%s` ( %s ) VALUES ( %s )".format(_name,columns.join(", "),bindValues);
_database.command(query,values);
}
}
    template replace(T)
{
void replace(T[][] values, string[] columns = null)
{
foreach (value; values)
{
replace(value,columns);
}
}
}
    template replace(T)
{
void replace(T[][] values, string[][] columns = null)
{
if (values.length != columns.length)
throw new TableException(" Array values and array columns need to be same length: %s != %s".format(values.length,columns.length),"sqlite/table.d",84);
foreach (index; 0 .. values.length)
{
replace(values[index],columns[index]);
}
}
}
    template update(T)
{
void update(T[] values, string[] columns, string condition)
{
string query = "UPDATE `%s` ( %s ) SET ( %s ) WHERE %s".format(_name,columns.join(", "),condition);
_database.command(query,values);
}
}
    template update(T)
{
void update(T[][] values, string[] columns, string condition)
{
foreach (value; values)
{
update(value,columns,condition);
}
}
}
    template update(T)
{
void update(T[][] values, string[][] columns, string[] conditions)
{
if (columns.length != conditions.length)
throw new TableException(" Array columns and array condition need to be same length: %s != %s".format(columns.length,conditions.length),"sqlite/table.d",102);
foreach (index; 0 .. columns.length)
{
update(values[index],columns[index],conditions[index]);
}
}
}
    Row[] select(string[] column, string statement = null);
    Row[] select(string[] column, string statement, Variant[] values...);
}
}
}

